import { h } from "@stencil/core";
export class PieSpinner {
    constructor() {
        /**
         * Shows the spinner
         */
        this.active = true;
    }
    render() {
        return (h("div", null,
            !this.active && h("slot", null),
            this.active ?
                h("div", { id: "pie-spinner-container" },
                    h("div", { id: "pie-spinner" },
                        h("svg", { class: "lds-spinner", width: "200px", height: "200px", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 100 100", preserveAspectRatio: "xMidYMid" },
                            h("g", { transform: "rotate(0 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-1.1916666666666667s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(30 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-1.0833333333333333s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(60 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.9750000000000001s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(90 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.8666666666666667s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(120 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.7583333333333333s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(150 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.65s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(180 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.5416666666666666s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(210 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.43333333333333335s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(240 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.325s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(270 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.21666666666666667s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(300 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.10833333333333334s", repeatCount: "indefinite" }))),
                            h("g", { transform: "rotate(330 50 50)" },
                                h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" },
                                    h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "0s", repeatCount: "indefinite" }))))))
                :
                    h("div", null)));
    }
    static get is() { return "pie-spinner"; }
    static get originalStyleUrls() { return {
        "$": ["pie-spinner.css"]
    }; }
    static get styleUrls() { return {
        "$": ["pie-spinner.css"]
    }; }
    static get properties() { return {
        "active": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "Shows the spinner"
            },
            "attribute": "active",
            "reflect": false,
            "defaultValue": "true"
        }
    }; }
}
