import { c as createCommonjsModule, u as unwrapExports } from './_commonjsHelpers-97e6d7b1.js';

var lib = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
class ModelUpdatedEvent extends CustomEvent {
    constructor(update, reset = false) {
        super(ModelUpdatedEvent.TYPE, { bubbles: true, detail: { update, reset } });
        this.update = update;
        this.reset = reset;
    }
}
ModelUpdatedEvent.TYPE = 'model.updated';
exports.ModelUpdatedEvent = ModelUpdatedEvent;
class DeleteImageEvent extends CustomEvent {
    constructor(src, done) {
        super(DeleteImageEvent.TYPE, { bubbles: true, detail: { src, done } });
        this.src = src;
        this.done = done;
    }
}
DeleteImageEvent.TYPE = 'delete.image';
exports.DeleteImageEvent = DeleteImageEvent;
class InsertImageEvent extends CustomEvent {
    constructor(handler) {
        super(InsertImageEvent.TYPE, { bubbles: true, detail: handler });
        this.handler = handler;
    }
}
InsertImageEvent.TYPE = 'insert.image';
exports.InsertImageEvent = InsertImageEvent;
class DeleteSoundEvent extends CustomEvent {
    constructor(src, done) {
        super(DeleteSoundEvent.TYPE, { bubbles: true, detail: { src, done } });
        this.src = src;
        this.done = done;
    }
}
DeleteSoundEvent.TYPE = 'delete.sound';
exports.DeleteSoundEvent = DeleteSoundEvent;
class InsertSoundEvent extends CustomEvent {
    constructor(handler) {
        super(InsertSoundEvent.TYPE, { bubbles: true, detail: handler });
        this.handler = handler;
    }
}
InsertSoundEvent.TYPE = 'insert.sound';
exports.InsertSoundEvent = InsertSoundEvent;

});

unwrapExports(lib);
var lib_1 = lib.ModelUpdatedEvent;
var lib_2 = lib.DeleteImageEvent;
var lib_3 = lib.InsertImageEvent;
var lib_4 = lib.DeleteSoundEvent;
var lib_5 = lib.InsertSoundEvent;

export { lib_2 as a, lib_5 as b, lib_4 as c, lib_1 as d, lib_3 as l };
